<?php
function sitCreateTablePostalCodes($db, $cfg) {
    $sql = 'CREATE TABLE `' . $cfg['tab']['sit_postal_codes'] . '` (
                            `Country` varchar(2) NOT NULL,
                            `PostalCode` varchar(20) NOT NULL,
                            `PlaceName` varchar(180) NOT NULL,
                            `AdminName1` varchar(100) NULL,
                            `AdminCode1` varchar(20) NULL,
                            `AdminName2` varchar(100) NULL,
                            `AdminCode2` varchar(20) NULL,
                            `AdminName3` varchar(100) NULL,
                            `AdminCode3` varchar(20) NULL,
                            `Latitude` float,
                            `Longitude` float,
                            `Accuracy` tinyint(1),
                            PRIMARY KEY (`Country`, `PostalCode`, `PlaceName`)
                         ) ENGINE = MyISAM';
    $db->query($sql);
}
function sitImportPostalCodes($db, $cfg, $cfgClient, $client) {
    $cfg['tab']['sit_postal_codes'] = $cfg['sql']['sqlprefix'] . '_sit_postal_codes';
    $sql = 'SELECT Country
            FROM ' . $cfg['tab']['sit_postal_codes'] . '
            LIMIT 0, 1';
    if (!$db->query($sql)) {
        sitCreateTablePostalCodes($db, $cfg);
    }
    $textfile = $cfgClient[$client]['upl']['path'] . 'DE.txt';
    if (is_file($textfile)) {
        $fp = fopen($textfile, 'r');
        while (($line = fgets($fp)) !== false) {
            $line = utf8_decode($line);
            $fields = explode(urldecode('%09'), $line);
            $sql = 'REPLACE INTO ' . $cfg['tab']['sit_postal_codes'] . ' (Country, PostalCode, PlaceName, AdminName1, AdminCode1, AdminName2, AdminCode2, AdminName3, AdminCode3, Latitude, Longitude, Accuracy)
                    VALUES ("' . $fields[0] . '", "' . $fields[1] . '", "' . $fields[2] . '", "' . $fields[3] . '", "' . $fields[4] . '", "' . $fields[5] . '", "' . $fields[6] . '", "' . $fields[7] . '", "' . $fields[8] . '", ' . $fields[9] . ', ' . $fields[10] . ', "' . $fields[11] . '")';
            $db->query($sql);
        }
        fclose($fp);
        unlink($textfile);
    }
}
function sitGetPostalCodes($db, $cfg, $Plz, $Entfernung) {
    $cfg['tab']['sit_postal_codes'] = $cfg['sql']['sqlprefix'] . '_sit_postal_codes';
    $Codes = array();
    
    $S = array();
    $sql = 'SELECT PostalCode, Latitude, Longitude
            FROM ' . $cfg['tab']['sit_postal_codes'] . '
            WHERE (PostalCode LIKE "' . $Plz . '%")
            ORDER BY Latitude, Longitude';
    $db->query($sql);
    while ($db->next_record()) {
        $S[] = array('P' => $db->f('PostalCode'), 'B' => $db->f('Latitude'), 'L' => $db->f('Longitude'));
    }
    for ($j = 0, $m = count($S); $j < $m; $j ++) {
        $Code = $S[$j]['P'];
        $OK = false;
        for ($i = 0, $n = count($Codes); $i < $n; $i ++) {
            if ($Codes[$i] == $Code) {
                $OK = true;
                break;
            }
        }
        if (!$OK) {
            $Codes[] = $Code;
        }
        $Breite = deg2rad($S[$j]['B']);
        $Laenge = deg2rad($S[$j]['L']);
        $sql = 'SELECT DISTINCT PostalCode
                FROM ' . $cfg['tab']['sit_postal_codes'] . '
                WHERE (6367.41 * SQRT(2 * (1 - cos(RADIANS(Latitude))
                              * cos(' . $Breite . ') * (sin(RADIANS(Longitude))
                              * sin(' . $Laenge . ') + cos(RADIANS(Longitude))
                              * cos(' . $Laenge . ')) - sin(RADIANS(Latitude))
                              * sin(' . $Breite . '))) <= ' . $Entfernung . ')';
        $db->query($sql);
        while ($db->next_record()) {
            $Code = $db->f('PostalCode');
            $OK = false;
            for ($i = 0, $n = count($Codes); $i < $n; $i ++) {
                if ($Codes[$i] == $Code) {
                    $OK = true;
                    break;
                }
            }
            if (!$OK) {
                $Codes[] = $Code;
            }
        }
    }
    return $Codes;
}
?>